#
# spec file for package libcaca
#
# Copyright (c) 2013 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


%define withjava 0
%define withpython 1
%bcond_without mono

Name:           libcaca
BuildRequires:  doxygen
BuildRequires:  fdupes
BuildRequires:  freetype2-devel
BuildRequires:  imlib2-devel
BuildRequires:  libtool
BuildRequires:  ncurses-devel
BuildRequires:  pkgconfig
BuildRequires:  slang-devel
BuildRequires:  xorg-x11
BuildRequires:  xorg-x11-devel
#texlive-latex
BuildRequires:  freeglut-devel
BuildRequires:  ftgl-devel
BuildRequires:  gcc-c++
BuildRequires:  java-devel
%if %{with mono}
BuildRequires:  mono-devel
%endif
BuildRequires:  python-devel
BuildRequires:  ruby-devel
BuildRequires:  xorg-x11-libs
Version:        0.99.beta18
Release:        44.4
Summary:        Library for Colour ASCII Art, text mode graphics
License:        SUSE-WTFPL-2.0
Group:          Development/Languages/C and C++
Url:            http://sam.zoy.org/projects/libcaca/
Source0:        http://caca.zoy.org/files/libcaca/%{name}-%{version}.tar.gz
Patch1:         libcaca-0.99-texbuild.patch
Patch2:         libcaca-X11_test.patch
Patch4:         libcaca-ruby_am_cflags.patch
Patch5:         libcaca-ruby_vendor_install.patch
Patch7:         libcaca-0.99.beta16-missing-GLU.patch
Patch9:         caca-no-build-date.patch
Patch10:        automake-1.12.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
%define rb_vendorarch %{_libdir}/ruby/vendor_ruby/%{rb_ver}/%{rb_arch}
%define rb_vendorlib %{_libdir}/ruby/vendor_ruby/%{rb_ver}

%description
libcaca is the Colour AsCii Art library. It provides high level
functions for colour text drawing, simple primitives for line, polygon
and ellipse drawing, as well as powerful image to text conversion
routines.

%package -n libcaca0
Summary:        Library for Colour ASCII Art, text mode graphics
Group:          Development/Languages/C and C++
Provides:       libcaca = %{version}
Obsoletes:      libcaca < %{version}
%if 0%{?suse_version} <= 1110
%define python_sitelib %_libdir/python2.6/site-packages
%endif

%description -n libcaca0
libcaca is the Colour AsCii Art library. It provides high level
functions for colour text drawing, simple primitives for line, polygon
and ellipse drawing, as well as powerful image to text conversion
routines.

%if "%(pkg-config --variable prefix x11 || echo /usr/X11R6)" == "/usr"
%define _xorg7libs %{_libdir}
%else
%define _xorg7libs /usr/X11R6/%{_lib}
%endif

%package devel
Summary:        Library for Colour ASCII Art, text mode graphics
Group:          Development/Languages/C and C++
#yes, nothing else is required to link other applications with "libcaca"
Requires:       %{name} = %{version}
Requires:       %{name}0-plugins = %{version}
%if 0%{?withjava} == 1
Requires:       %{name}0-java = %{version}
%endif

%description devel
This package contains the header files and static libraries needed to
compile applications or shared objects that use libcaca.

%if %{with mono}
%package csharp
Summary:        C# support for libcaca
Group:          Development/Languages/Mono
Requires:       %{name} = %{version}
Requires:       mono

%description csharp
This package contains all that is needed to use libcaca from C# code.
%endif

%if 0%{?withjava} == 1

%package -n libcaca0-java
Summary:        Java support for libcaca
Group:          Development/Languages/Java
Requires:       %{name} = %{version}
Requires:       java

%description -n libcaca0-java
This package contains all that is needed to use libcaca from java.

%endif

%if 0%{?withpython} == 1

%package python
Summary:        Python support for libcaca
Group:          Development/Languages/Python
Requires:       %{name} = %{version}
Requires:       python-base = %{py_ver}
%if 0%{?suse_version} >= 1120
BuildArch:      noarch
%endif

%description python
This package contains all that is needed to use libcaca from python.

%endif

%package -n libcaca0-plugins
Summary:        Plugins for libcaca
Group:          Development/Languages/C and C++
Requires:       %{name} = %{version}

%description -n libcaca0-plugins
This package contains gl and x11 plugins for caca.

%package ruby
Summary:        Ruby bindings for libcaca
Group:          Development/Languages/Ruby
Requires:       %{name} = %{version}
Requires:       ruby

%description ruby
All that is needed to use libcaca from ruby code.

%package -n caca-utils
Summary:        Colour ASCII Art Text mode graphics utilities based on libcaca
Group:          Amusements/Toys/Graphics

%description -n caca-utils
This package contains utilities and demonstration programs for libcaca,
the Colour AsCii Art library.

cacaview is a simple image viewer for the terminal. It opens most image
formats such as JPEG, PNG, GIF etc. and renders them on the terminal
using ASCII art. The user can zoom and scroll the image, set the
dithering method or enable anti-aliasing.

cacaball is a tiny graphic program that renders animated ASCII
metaballs on the screen, cacafire is a port of AALib's aafire and
displays burning ASCII art flames, and cacademo is a simple application
that shows the libcaca rendering features such as line and ellipses
drawing, triangle filling and sprite blitting.


%prep
chmod 0644 %{S:0}
%setup -q -n libcaca-%{version}
%patch2
%patch4
%patch5
%patch7
%patch9
%patch1
%patch10 -p1
RUBY="ruby-`echo %{rb_ver} | sed 's|\.[^\.]*$||'`"
find . -type f -exec sed -i "s|ruby-1.9|$RUBY|" \{\} \;

%build
autoreconf -fi
export CFLAGS="$CFLAGS %{optflags} -I../caca/"
export CXXFLAGS="$CXXFLAGS %{optflags}"
%configure --with-pic \
    --program-prefix="%{?_program_prefix}" \
    --enable-slang \
    --enable-ncurses \
    --enable-x11 \
    --x-libraries=%{_xorg7libs} \
    --enable-imlib2 \
    --enable-gl \
    --enable-csharp \
    --enable-doc \
    --enable-shared=yes \
    --enable-static=no \
    --enable-conio=no \
    --enable-plugins \
%if 0%{?withjava} == 1
    --enable-java
%else
    --enable-java=no
%endif
make %{?_smp_mflags}

%install
%makeinstall
%{__rm} -f %{buildroot}%{_libdir}/*.la
%{__rm} -f %{buildroot}%{_libdir}/caca/*.la
%if 0%{?withjava} == 1
%{__rm} -f %{buildroot}%{_libdir}/jni/libcaca-java.la
%endif

%fdupes -s %{buildroot}%{python_sitelib}/caca/
%fdupes -s %{buildroot}%{_mandir}/
%if %{with mono}
%fdupes -s %{buildroot}%{_libdir}/mono
%endif

%post -n libcaca0 -p /sbin/ldconfig

%postun -n libcaca0 -p /sbin/ldconfig

%post -n libcaca0-plugins -p /sbin/ldconfig

%postun -n libcaca0-plugins -p /sbin/ldconfig

%if 0%{?withjava} == 1

%post -n libcaca0-java -p /sbin/ldconfig

%postun -n libcaca0-java -p /sbin/ldconfig
%endif

%files -n libcaca0
%defattr(-, root, root, 0755)
%doc AUTHORS ChangeLog COPYING NEWS NOTES README THANKS
%{_libdir}/*.so.*

%files devel
%defattr(-, root, root, 0755)
%dir %{_libdir}/caca
%{_libdir}/*.so
%{_libdir}/caca/libx11_plugin.so
%{_libdir}/caca/libgl_plugin.so
%{_bindir}/caca-config
%{_libdir}/pkgconfig/*.pc
%{_includedir}/*
%{_mandir}/man1/caca-config.1*
%{_mandir}/man3/*
%{_datadir}/doc/libcucul-dev
%{_datadir}/doc/libcaca-dev
%if 0%{?withjava} == 1
%{_libdir}/jni/libcaca-java.so
%endif

%if %{with mono}
%files csharp
%defattr(-, root, root, 0755)
%{_libdir}/mono
%endif

%files ruby
%defattr(-, root, root, 0755)
%{rb_vendorarch}/*
%{rb_vendorlib}/caca.rb

%if 0%{?withjava} == 1

%files -n libcaca0-java
%defattr(-, root, root, 0755)
%{_libdir}/jni/libcaca-java.so.0
%{_libdir}/jni/libcaca-java.so.0.0.0
%{_datadir}/java/libjava.jar
%endif

%if 0%{?withpython} == 1

%files python
%defattr(-, root, root, 0755)
%dir %{python_sitelib}/caca
%{python_sitelib}/caca/__init__.py
%{python_sitelib}/caca/__init__.pyc
%{python_sitelib}/caca/__init__.pyo
%{python_sitelib}/caca/canvas.py
%{python_sitelib}/caca/canvas.pyc
%{python_sitelib}/caca/canvas.pyo
%{python_sitelib}/caca/common.py
%{python_sitelib}/caca/common.pyc
%{python_sitelib}/caca/common.pyo
%{python_sitelib}/caca/display.py
%{python_sitelib}/caca/display.pyc
%{python_sitelib}/caca/display.pyo
%{python_sitelib}/caca/dither.py
%{python_sitelib}/caca/dither.pyc
%{python_sitelib}/caca/dither.pyo
%{python_sitelib}/caca/font.py
%{python_sitelib}/caca/font.pyc
%{python_sitelib}/caca/font.pyo
%endif

%files -n libcaca0-plugins
%defattr(-, root, root, 0755)
%dir %{_libdir}/caca
%{_libdir}/caca/libgl_plugin.so.0
%{_libdir}/caca/libgl_plugin.so.0.0.0
%{_libdir}/caca/libx11_plugin.so.0
%{_libdir}/caca/libx11_plugin.so.0.0.0

%files -n caca-utils
%defattr(-, root, root, 0755)
%{_bindir}/cacademo
%{_bindir}/cacafire
%{_bindir}/cacaview
%{_bindir}/cacaplay
%{_bindir}/cacaclock
%{_bindir}/cacaserver
%{_bindir}/img2txt
%{_datadir}/libcaca
%{_mandir}/man1/cacademo.1*
%{_mandir}/man1/cacafire.1*
%{_mandir}/man1/cacaview.1*
%{_mandir}/man1/cacaplay.1*
%{_mandir}/man1/cacaserver.1*
%{_mandir}/man1/img2txt.1*

%changelog
* Wed May 29 2013 mhrusecky@suse.cz
- fix build with different versions of ruby
* Sun Mar 17 2013 dmueller@suse.com
- add buildconditional to build optionally without mono
* Wed Jun  6 2012 cfarrell@suse.com
- license update: SUSE-WTFPL-2.0
  SPDX format (choose from http://www.spdx.org/licenses or the list linked
  at license.opensuse.org)
* Tue May 29 2012 puzel@suse.com
- fix build with automake-12.1
* Tue May 29 2012 jengelh@inai.de
- Use autoreconf instead of ./bootstrap since (a) that works,
  (b) avoids the inflexible handcrafted automake version check
* Mon May 14 2012 coolo@suse.com
- update to libcaca-0.99beta18
  - new "cacaclock" utility
  - improved FIGlet support
  - improved Python and Ruby bindings
  - numerous improvements and bugfixes
- fix build with ruby 1.9 and re-enable python support
* Sun Nov 13 2011 coolo@suse.com
- add libtool as explicit buildrequire to avoid implicit dependency
  from prjconf
* Tue Apr 12 2011 toddrme2178@gmail.com
- Add 32bit compatibility libraries
* Wed Jan 26 2011 davejplater@gmail.com
- Fix libcaca-devel Requires: libcaca-plugins to correct
  Requires: libcaca0-plugins.
* Sat Nov 20 2010 davejplater@gmail.com
- Update to libcaca-0.99beta17
- Removed patches: libcaca-no_slang_acsmap.patch for < 10.1
  libcaca-no_man3_pages.patch - pending investigation
  remove_badwords.patch - waiting for confirmation about bad words
  libcaca-0.99.beta16-libtool.patch - libtool method changed.
- Fixed patches : libcaca-ruby_am_cflags.patch,
  libcaca-ruby_vendor_install.patch, caca-no-build-date.patch
  and libcaca-0.99.beta16-missing-GLU.patch.
- Upstream changes : (See Changelog for more)
  * Add triangle texture mapping to NEWS and update ChangeLog.
  * Disable set_dither_palette until we really use it.
  * Fix distribution of Java source.
  * Large source code cleanup, getting rid of spaces, tabs, and svn keywords.
  * Nicer make check output for our custom tests.
  * Add missing ruby/test file to the distributed tarball.
  * Update logo in the PHP bindings.
  * Replace the old caca texture with a copy of our new logo.
  * Add #undef __extern at the end of caca0.h. Thanks to Carlo Bramini for
  * fixing this in #48.
  * Only define CACA_ALIAS with gcc > 3 (instead of >= 3). Patch courtesy of
  * Carlo Bramini. Addresses #48.
  * Add brief documentation to figfont functions.
  * Split check-build into check-doygen, check-source and check-win32.
  * Document file functions and fix a few issues here and there.
  * Move some configuration stuff from build-kernel into configure.ac.
  * Activate colour toilet font support.
  * Don't fail the check-build test if documentation was not built.
  * Simpler and more accurate troff colour selection.
  * Always draw all background in troff output, on beginning of lines too
  * Fix the source code to reduce testsuite errors.
  * Always draw all background in troff output
  * Fix check-build verbosity.
  * Fix shrext_cmds usage in configure.ac.
  * Map colors to the ones known by groff, defining mines don't work
  * Improve a bit troff export
  * Fix libcaca.a linkage (was off by one argument), fill memory with 0xCACA.
* Fri Nov 19 2010 coolo@novell.com
- disable pdf API reference documentation, it fails to build
  with newer doxygen and the html documentation should be enough
  for the package
* Mon Aug 30 2010 cristian.rodriguez@opensuse.org
- Do not include build date in binaries
* Tue Nov  3 2009 coolo@novell.com
- updated patches to apply with fuzz=0
* Mon Mar 16 2009 crrodriguez@suse.de
- fix build, missing -lGLU
- Update to version 0.99.beta16
- libcucul was merged back into libcaca for more clarity
- internal FIGlet font support
- use C99 types in public headers
- runtime support for output drivers
- BBcode export support
* Wed Jan 28 2009 crrodriguez@suse.de
- remove "la" files
* Thu Dec  4 2008 cfarrell@suse.de
- added patch to remove badwords because of bnc#441358
* Thu Jun 12 2008 pth@suse.de
- Build dynamic libraries, disable creation of static ones.
- Compile with OpenGL support.
- Install ruby bindings in vendorarch/vendorlib.
- Fix file list.
* Wed Feb 13 2008 pth@suse.de
- Update to 0.99beta13:
  - device-dependent cursor support
  - event API rewrite
  - Ruby bindings
  - Massive C# bindings improvements
  - Python sample code
  - support for 90-degree canvas rotation
  - better behaviour when trying to output Unicode on an ASCII terminal
  - the built-in font now supports the Geometric Shapes, Halfwidth and Fullwidth
  Forms and Miscellaneous Symbols Unicode blocks
  - new rotozoom effect in cacademo
  - preliminary .NET bindings
  - blitting canvases now makes use of the canvas' handle coordinates
  - import functions can read streamed data
  - attribute to colorspace transformations
  - added katakana and hiragana glyphs to the built-in font
  - support for blink, bold, italics and underline attributes
  - fixed Imlib2 support in cacaview
  - fixed buffer overflows in the file importer
  - support for fullwidth Unicode characters
  - transparency support in the UTF-8 importer and exporter
  - ANSI importer now handles transparency and UTF-8
  - various memory leaks were fixed
  - implemented cucul_getchar() and cucul_get_color()
  - handle transparency in the IRC export
  - new cropping and expanding filters
  - full Unicode support in the OpenGL driver
  - all demos except cacafire were merged into cacademo
  - added a compatibility layer for pre-1.x libcaca applications
  - libcaca functions use errno for error reporting
  - ANSI importer
  - cacadraw, an ANSI viewer that will evolve into an editor
  - Unicode input and output support for SLang and ncurses
  - license switched to WTFPL
  - libcaca was split into libcucul, a standalone text manipulation backend,
    and libcaca, the display and user input frontend
  - TrueColor (more than 16 colours) support
  - Floyd-Steinberg dithering
  - gamma correction
  - export functions for HTML, IRC, ANSI, SVG, PostScript, TGA...
  - builtin fonts for device-independent bitmap output
  - various text transformation routines (rotation, horizontal flip...)
  - OpenGL renderer
  - kernel mode to build libcaca programs into a bootable x86 kernel
  - cacaserver, a telnet server that can be hooked to libcaca applications
  - img2irc, an image to IRC conversion utility
* Sun Apr 22 2007 ro@suse.de
- use texlive for building
* Fri Mar 30 2007 rguenther@suse.de
- Add ncurses-devel BuildRequires.
* Fri Aug  4 2006 pth@suse.de
- Adapt to new X11 paths.
* Wed Mar 29 2006 pth@suse.de
- Fix BuildRequires.
* Wed Mar 29 2006 pth@suse.de
- Add X11 devel files to BuildRequires.
* Wed Jan 25 2006 mls@suse.de
- converted neededforbuild to BuildRequires
* Mon Dec 19 2005 ro@suse.de
- added missing manpage symlinks to filelist
* Fri Nov 25 2005 pth@suse.de
- Initial package.
  - undef clashing acs_map from slang.h
  - don't try to install non-existing man3 pages
  - install documentation to different directory
